<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>40.30</title>

    <title>Users CRUD</title>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
    <!-- Data Table-->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
    <div class="container">
        <h1 class="text-center">Danh sách người dùng đăng ký</h1>
        <div class="my-4">
            <button class="btn btn-success">Thêm user</button>
        </div>
        <table id="user-table" class="table table-hover table-striped table-bordered">
            <thead>
                <tr>
                    <th>Id</th>
                    <th>Firstname</th>
                    <th>Lastname</th>
                    <th>Country</th>
                    <th>Subject</th>
                    <th>Customer Type</th>
                    <th>Register Status</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>
</body>

<script>
    const gUserId = 0;
    const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";
    const gDATA = ['id', 'firstname', 'lastname', 'country', 'subject', 'customerType', 'registerStatus', 'action'];

    const gID_COL = 0;
    const gFIRST_NAME_COL = 1;
    const gLAST_NAME_COL = 2;
    const gCOUNTRY_COL = 3;
    const gSUBJECT_COL = 4;
    const gCUSTOMER_TYPE_COL = 5;
    const gREGISTER_STATUS_COL = 6;
    const gACTION_COL = 7;

    var gUserTable = $("#user-table").DataTable({
        columns: [
            { data: gDATA[gID_COL] },
            { data: gDATA[gFIRST_NAME_COL] },
            { data: gDATA[gLAST_NAME_COL] },
            { data: gDATA[gCOUNTRY_COL] },
            { data: gDATA[gSUBJECT_COL] },
            { data: gDATA[gCUSTOMER_TYPE_COL] },
            { data: gDATA[gREGISTER_STATUS_COL] },
            { data: gDATA[gACTION_COL] },
        ],
        columnDefs: [
            {
                targets: gACTION_COL,
                defaultContent: `<img class="edit-user" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
<img class="delete-user" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
`
            }
        ]
    })


    $(document).ready(function () {
        onPageLoading();
        $("#user-table").on("click", ".edit-user",function(){
            onEditBtnClick(this);
        })
        $("#user-table").on("click", ".delete-user",function(){
            onDeleteBtnClick(this);
        })
    })

    function onEditBtnClick(paramUser){
        var vId = getIdByUser(paramUser);
        console.log(vId);
    }

    function onDeleteBtnClick(paramUser){
        var vId = getIdByUser(paramUser);
        console.log(vId);
    }

    function onPageLoading() {
        callApiUser();
    }

    function loadDataIntoTable(list) {
        gUserTable.clear();
        gUserTable.rows.add(list);
        gUserTable.draw();
    };

    function callApiUser() {
        $.ajax({
            url: gBASE_URL,
            type: 'get',
            async: false,
            success: function (res) {
                console.log(res);
                loadDataIntoTable(res);
            },
            error: function (error) {
                console.log(error)
            }
        })
    }

    function getIdByUser(paramUser){
        var vRow = $(paramUser).parents("tr");
        var vData = gUserTable.row(vRow).data();
        return vData.id;
    }
</script>


</html>